/*         glTrans.h
 * definition des translations entre nom et valeurs 
 * pour l'utilisation de la librairie GL de l'IRIS
 *  D.Ploix, novembre 93
 */

#ifndef _glTrans_h_
#define _glTrans_h_

#include <GL/gl.h>
#include <GL/glu.h>
#define GL_TTABLE_SIZE   496

struct _gl_trans_struct_ {
  char *nom;
  long value;
} GLTTable[GL_TTABLE_SIZE] = {
  {"GLU_AUTO_LOAD_MATRIX\0", GLU_AUTO_LOAD_MATRIX},
  {"GLU_CCW\0", GLU_CCW},
  {"GLU_CULLING\0", GLU_CULLING},
  {"GLU_CW\0", GLU_CW},
  {"GLU_DISPLAY_MODE\0", GLU_DISPLAY_MODE},
  {"GLU_EXTERIOR\0", GLU_EXTERIOR},
  {"GLU_FALSE\0", GLU_FALSE},
  {"GLU_FILL\0", GLU_FILL},
  {"GLU_FLAT\0", GLU_FLAT},
  {"GLU_INSIDE\0", GLU_INSIDE},
  {"GLU_INTERIOR\0", GLU_INTERIOR},
  {"GLU_INVALID_ENUM\0", GLU_INVALID_ENUM},
  {"GLU_INVALID_VALUE\0", GLU_INVALID_VALUE},
  {"GLU_LINE\0", GLU_LINE},
  {"GLU_MAP1_TRIM_2\0", GLU_MAP1_TRIM_2},
  {"GLU_MAP1_TRIM_3\0", GLU_MAP1_TRIM_3},
  {"GLU_NONE\0", GLU_NONE},
  {"GLU_NURBS_ERROR10\0", GLU_NURBS_ERROR10},
  {"GLU_NURBS_ERROR11\0", GLU_NURBS_ERROR11},
  {"GLU_NURBS_ERROR12\0", GLU_NURBS_ERROR12},
  {"GLU_NURBS_ERROR13\0", GLU_NURBS_ERROR13},
  {"GLU_NURBS_ERROR14\0", GLU_NURBS_ERROR14},
  {"GLU_NURBS_ERROR15\0", GLU_NURBS_ERROR15},
  {"GLU_NURBS_ERROR16\0", GLU_NURBS_ERROR16},
  {"GLU_NURBS_ERROR17\0", GLU_NURBS_ERROR17},
  {"GLU_NURBS_ERROR18\0", GLU_NURBS_ERROR18},
  {"GLU_NURBS_ERROR19\0", GLU_NURBS_ERROR19},
  {"GLU_NURBS_ERROR1\0", GLU_NURBS_ERROR1},
  {"GLU_NURBS_ERROR20\0", GLU_NURBS_ERROR20},
  {"GLU_NURBS_ERROR21\0", GLU_NURBS_ERROR21},
  {"GLU_NURBS_ERROR22\0", GLU_NURBS_ERROR22},
  {"GLU_NURBS_ERROR23\0", GLU_NURBS_ERROR23},
  {"GLU_NURBS_ERROR24\0", GLU_NURBS_ERROR24},
  {"GLU_NURBS_ERROR25\0", GLU_NURBS_ERROR25},
  {"GLU_NURBS_ERROR26\0", GLU_NURBS_ERROR26},
  {"GLU_NURBS_ERROR27\0", GLU_NURBS_ERROR27},
  {"GLU_NURBS_ERROR28\0", GLU_NURBS_ERROR28},
  {"GLU_NURBS_ERROR29\0", GLU_NURBS_ERROR29},
  {"GLU_NURBS_ERROR2\0", GLU_NURBS_ERROR2},
  {"GLU_NURBS_ERROR30\0", GLU_NURBS_ERROR30},
  {"GLU_NURBS_ERROR31\0", GLU_NURBS_ERROR31},
  {"GLU_NURBS_ERROR32\0", GLU_NURBS_ERROR32},
  {"GLU_NURBS_ERROR33\0", GLU_NURBS_ERROR33},
  {"GLU_NURBS_ERROR34\0", GLU_NURBS_ERROR34},
  {"GLU_NURBS_ERROR35\0", GLU_NURBS_ERROR35},
  {"GLU_NURBS_ERROR36\0", GLU_NURBS_ERROR36},
  {"GLU_NURBS_ERROR37\0", GLU_NURBS_ERROR37},
  {"GLU_NURBS_ERROR3\0", GLU_NURBS_ERROR3},
  {"GLU_NURBS_ERROR4\0", GLU_NURBS_ERROR4},
  {"GLU_NURBS_ERROR5\0", GLU_NURBS_ERROR5},
  {"GLU_NURBS_ERROR6\0", GLU_NURBS_ERROR6},
  {"GLU_NURBS_ERROR7\0", GLU_NURBS_ERROR7},
  {"GLU_NURBS_ERROR8\0", GLU_NURBS_ERROR8},
  {"GLU_NURBS_ERROR9\0", GLU_NURBS_ERROR9},
  {"GLU_OUTLINE_PATCH\0", GLU_OUTLINE_PATCH},
  {"GLU_OUTLINE_POLYGON\0", GLU_OUTLINE_POLYGON},
  {"GLU_OUTSIDE\0", GLU_OUTSIDE},
  {"GLU_OUT_OF_MEMORY\0", GLU_OUT_OF_MEMORY},
  {"GLU_POINT\0", GLU_POINT},
  {"GLU_SAMPLING_TOLERANCE\0", GLU_SAMPLING_TOLERANCE},
  {"GLU_SILHOUETTE\0", GLU_SILHOUETTE},
  {"GLU_SMOOTH\0", GLU_SMOOTH},
  {"GLU_TESS_ERROR1\0", GLU_TESS_ERROR1},
  {"GLU_TESS_ERROR2\0", GLU_TESS_ERROR2},
  {"GLU_TESS_ERROR3\0", GLU_TESS_ERROR3},
  {"GLU_TESS_ERROR4\0", GLU_TESS_ERROR4},
  {"GLU_TESS_ERROR5\0", GLU_TESS_ERROR5},
  {"GLU_TESS_ERROR6\0", GLU_TESS_ERROR6},
  {"GLU_TESS_ERROR7\0", GLU_TESS_ERROR7},
  {"GLU_TESS_ERROR8\0", GLU_TESS_ERROR8},
  {"GLU_TRUE\0", GLU_TRUE},
  {"GLU_UNKNOWN\0", GLU_UNKNOWN},
  {"GL_2D\0", GL_2D}, 
  {"GL_2_BYTES\0", GL_2_BYTES}, 
  {"GL_3D\0", GL_3D}, 
  {"GL_3D_COLOR\0", GL_3D_COLOR}, 
  {"GL_3D_COLOR_TEXTURE\0", GL_3D_COLOR_TEXTURE}, 
  {"GL_3_BYTES\0", GL_3_BYTES}, 
  {"GL_4D_COLOR_TEXTURE\0", GL_4D_COLOR_TEXTURE}, 
  {"GL_4_BYTES\0", GL_4_BYTES}, 
  {"GL_ACCUM\0", GL_ACCUM},
  {"GL_ACCUM_ALPHA_BITS\0", GL_ACCUM_ALPHA_BITS}, 
  {"GL_ACCUM_BLUE_BITS\0", GL_ACCUM_BLUE_BITS}, 
  {"GL_ACCUM_BUFFER_BIT\0", GL_ACCUM_BUFFER_BIT}, 
  {"GL_ACCUM_CLEAR_VALUE\0", GL_ACCUM_CLEAR_VALUE}, 
  {"GL_ACCUM_GREEN_BITS\0", GL_ACCUM_GREEN_BITS}, 
  {"GL_ACCUM_RED_BITS\0", GL_ACCUM_RED_BITS}, 
  {"GL_ADD\0", GL_ADD}, 
  {"GL_ALL_ATTRIB_BITS\0", GL_ALL_ATTRIB_BITS}, 
  {"GL_ALPHA\0", GL_ALPHA}, 
  {"GL_ALPHA_BIAS\0", GL_ALPHA_BIAS}, 
  {"GL_ALPHA_BITS\0", GL_ALPHA_BITS}, 
  {"GL_ALPHA_SCALE\0", GL_ALPHA_SCALE}, 
  {"GL_ALPHA_TEST\0", GL_ALPHA_TEST}, 
  {"GL_ALPHA_TEST_FUNC\0", GL_ALPHA_TEST_FUNC}, 
  {"GL_ALPHA_TEST_REF\0", GL_ALPHA_TEST_REF}, 
  {"GL_ALWAYS\0", GL_ALWAYS}, 
  {"GL_AMBIENT\0", GL_AMBIENT}, 
  {"GL_AMBIENT_AND_DIFFUSE\0", GL_AMBIENT_AND_DIFFUSE}, 
  {"GL_AND\0", GL_AND}, 
  {"GL_AND_INVERTED\0", GL_AND_INVERTED}, 
  {"GL_AND_REVERSE\0", GL_AND_REVERSE}, 
  {"GL_ATTRIB_STACK_DEPTH\0", GL_ATTRIB_STACK_DEPTH}, 
  {"GL_AUTO_NORMAL\0", GL_AUTO_NORMAL}, 
  {"GL_AUX0\0", GL_AUX0}, 
  {"GL_AUX1\0", GL_AUX1}, 
  {"GL_AUX2\0", GL_AUX2}, 
  {"GL_AUX3\0", GL_AUX3}, 
  {"GL_AUX_BUFFERS\0", GL_AUX_BUFFERS}, 
  {"GL_BACK\0", GL_BACK}, 
  {"GL_BACK_LEFT\0", GL_BACK_LEFT}, 
  {"GL_BACK_RIGHT\0", GL_BACK_RIGHT}, 
  {"GL_BITMAP\0", GL_BITMAP}, 
  {"GL_BITMAP_TOKEN\0", GL_BITMAP_TOKEN}, 
  {"GL_BLEND\0", GL_BLEND}, 
  {"GL_BLEND_DST\0", GL_BLEND_DST}, 
  {"GL_BLEND_SRC\0", GL_BLEND_SRC}, 
  {"GL_BLUE\0", GL_BLUE}, 
  {"GL_BLUE_BIAS\0", GL_BLUE_BIAS}, 
  {"GL_BLUE_BITS\0", GL_BLUE_BITS}, 
  {"GL_BLUE_SCALE\0", GL_BLUE_SCALE}, 
  {"GL_BYTE\0", GL_BYTE}, 
  {"GL_CCW\0", GL_CCW}, 
  {"GL_CLAMP\0", GL_CLAMP}, 
  {"GL_CLEAR\0", GL_CLEAR}, 
  {"GL_CLIP_PLANE0\0", GL_CLIP_PLANE0}, 
  {"GL_CLIP_PLANE1\0", GL_CLIP_PLANE1}, 
  {"GL_CLIP_PLANE2\0", GL_CLIP_PLANE2}, 
  {"GL_CLIP_PLANE3\0", GL_CLIP_PLANE3}, 
  {"GL_CLIP_PLANE4\0", GL_CLIP_PLANE4}, 
  {"GL_CLIP_PLANE5\0", GL_CLIP_PLANE5}, 
  {"GL_COEFF\0", GL_COEFF}, 
  {"GL_COLOR\0", GL_COLOR}, 
  {"GL_COLOR_BUFFER_BIT\0", GL_COLOR_BUFFER_BIT}, 
  {"GL_COLOR_CLEAR_VALUE\0", GL_COLOR_CLEAR_VALUE}, 
  {"GL_COLOR_INDEXES\0", GL_COLOR_INDEXES}, 
  {"GL_COLOR_INDEX\0", GL_COLOR_INDEX}, 
  {"GL_COLOR_MATERIAL\0", GL_COLOR_MATERIAL}, 
  {"GL_COLOR_MATERIAL_FACE\0", GL_COLOR_MATERIAL_FACE}, 
  {"GL_COLOR_MATERIAL_PARAMETER\0", GL_COLOR_MATERIAL_PARAMETER}, 
  {"GL_COLOR_WRITEMASK\0", GL_COLOR_WRITEMASK}, 
  {"GL_COMPILE\0", GL_COMPILE}, 
  {"GL_COMPILE_AND_EXECUTE\0", GL_COMPILE_AND_EXECUTE}, 
  {"GL_CONSTANT_ATTENUATION\0", GL_CONSTANT_ATTENUATION}, 
  {"GL_COPY\0", GL_COPY}, 
  {"GL_COPY_INVERTED\0", GL_COPY_INVERTED}, 
  {"GL_COPY_PIXEL_TOKEN\0", GL_COPY_PIXEL_TOKEN}, 
  {"GL_CULL_FACE\0", GL_CULL_FACE}, 
  {"GL_CULL_FACE_MODE\0", GL_CULL_FACE_MODE}, 
  {"GL_CURRENT_BIT\0", GL_CURRENT_BIT}, 
  {"GL_CURRENT_COLOR\0", GL_CURRENT_COLOR}, 
  {"GL_CURRENT_INDEX\0", GL_CURRENT_INDEX}, 
  {"GL_CURRENT_NORMAL\0", GL_CURRENT_NORMAL}, 
  {"GL_CURRENT_RASTER_COLOR\0", GL_CURRENT_RASTER_COLOR}, 
  {"GL_CURRENT_RASTER_DISTANCE\0", GL_CURRENT_RASTER_DISTANCE}, 
  {"GL_CURRENT_RASTER_INDEX\0", GL_CURRENT_RASTER_INDEX}, 
  {"GL_CURRENT_RASTER_POSITION\0", GL_CURRENT_RASTER_POSITION}, 
  {"GL_CURRENT_RASTER_POSITION_VALID\0", GL_CURRENT_RASTER_POSITION_VALID}, 
  {"GL_CURRENT_RASTER_TEXTURE_COORDS\0", GL_CURRENT_RASTER_TEXTURE_COORDS}, 
  {"GL_CURRENT_TEXTURE_COORDS\0", GL_CURRENT_TEXTURE_COORDS}, 
  {"GL_CW\0", GL_CW}, 
  {"GL_DECAL\0", GL_DECAL}, 
  {"GL_DECR\0", GL_DECR}, 
  {"GL_DEPTH\0", GL_DEPTH}, 
  {"GL_DEPTH_BIAS\0", GL_DEPTH_BIAS}, 
  {"GL_DEPTH_BITS\0", GL_DEPTH_BITS}, 
  {"GL_DEPTH_BUFFER_BIT\0", GL_DEPTH_BUFFER_BIT}, 
  {"GL_DEPTH_CLEAR_VALUE\0", GL_DEPTH_CLEAR_VALUE}, 
  {"GL_DEPTH_COMPONENT\0", GL_DEPTH_COMPONENT}, 
  {"GL_DEPTH_FUNC\0", GL_DEPTH_FUNC}, 
  {"GL_DEPTH_RANGE\0", GL_DEPTH_RANGE}, 
  {"GL_DEPTH_SCALE\0", GL_DEPTH_SCALE}, 
  {"GL_DEPTH_TEST\0", GL_DEPTH_TEST}, 
  {"GL_DEPTH_WRITEMASK\0", GL_DEPTH_WRITEMASK}, 
  {"GL_DIFFUSE\0", GL_DIFFUSE}, 
  {"GL_DITHER\0", GL_DITHER}, 
  {"GL_DOMAIN\0", GL_DOMAIN}, 
  {"GL_DONT_CARE\0", GL_DONT_CARE}, 
  {"GL_DOUBLEBUFFER\0", GL_DOUBLEBUFFER}, 
  {"GL_DRAW_BUFFER\0", GL_DRAW_BUFFER}, 
  {"GL_DRAW_PIXEL_TOKEN\0", GL_DRAW_PIXEL_TOKEN}, 
  {"GL_DST_ALPHA\0", GL_DST_ALPHA}, 
  {"GL_DST_COLOR\0", GL_DST_COLOR}, 
  {"GL_EDGE_FLAG\0", GL_EDGE_FLAG}, 
  {"GL_EMISSION\0", GL_EMISSION}, 
  {"GL_ENABLE_BIT\0", GL_ENABLE_BIT}, 
  {"GL_EQUAL\0", GL_EQUAL}, 
  {"GL_EQUIV\0", GL_EQUIV}, 
  {"GL_EVAL_BIT\0", GL_EVAL_BIT}, 
  {"GL_EXP2\0", GL_EXP2}, 
  {"GL_EXP\0", GL_EXP}, 
  {"GL_EXTENSIONS\0", GL_EXTENSIONS}, 
  {"GL_EYE_LINEAR\0", GL_EYE_LINEAR}, 
  {"GL_EYE_PLANE\0", GL_EYE_PLANE}, 
  {"GL_FALSE\0", GL_FALSE}, 
  {"GL_FASTEST\0", GL_FASTEST}, 
  {"GL_FEEDBACK\0", GL_FEEDBACK}, 
  {"GL_FILL\0", GL_FILL}, 
  {"GL_FLAT\0", GL_FLAT}, 
  {"GL_FLOAT\0", GL_FLOAT}, 
  {"GL_FOG\0", GL_FOG}, 
  {"GL_FOG_BIT\0", GL_FOG_BIT}, 
  {"GL_FOG_COLOR\0", GL_FOG_COLOR}, 
  {"GL_FOG_DENSITY\0", GL_FOG_DENSITY}, 
  {"GL_FOG_END\0", GL_FOG_END}, 
  {"GL_FOG_HINT\0", GL_FOG_HINT}, 
  {"GL_FOG_INDEX\0", GL_FOG_INDEX}, 
  {"GL_FOG_MODE\0", GL_FOG_MODE}, 
  {"GL_FOG_START\0", GL_FOG_START}, 
  {"GL_FRONT\0", GL_FRONT}, 
  {"GL_FRONT_AND_BACK\0", GL_FRONT_AND_BACK}, 
  {"GL_FRONT_FACE\0", GL_FRONT_FACE}, 
  {"GL_FRONT_LEFT\0", GL_FRONT_LEFT}, 
  {"GL_FRONT_RIGHT\0", GL_FRONT_RIGHT}, 
  {"GL_GEQUAL\0", GL_GEQUAL}, 
  {"GL_GREATER\0", GL_GREATER}, 
  {"GL_GREEN\0", GL_GREEN}, 
  {"GL_GREEN_BIAS\0", GL_GREEN_BIAS}, 
  {"GL_GREEN_BITS\0", GL_GREEN_BITS}, 
  {"GL_GREEN_SCALE\0", GL_GREEN_SCALE}, 
  {"GL_HINT_BIT\0", GL_HINT_BIT}, 
  {"GL_INCR\0", GL_INCR}, 
  {"GL_INDEX_BITS\0", GL_INDEX_BITS}, 
  {"GL_INDEX_CLEAR_VALUE\0", GL_INDEX_CLEAR_VALUE}, 
  {"GL_INDEX_MODE\0", GL_INDEX_MODE}, 
  {"GL_INDEX_OFFSET\0", GL_INDEX_OFFSET}, 
  {"GL_INDEX_SHIFT\0", GL_INDEX_SHIFT}, 
  {"GL_INDEX_WRITEMASK\0", GL_INDEX_WRITEMASK}, 
  {"GL_INT\0", GL_INT}, 
  {"GL_INVALID_ENUM\0", GL_INVALID_ENUM}, 
  {"GL_INVALID_OPERATION\0", GL_INVALID_OPERATION}, 
  {"GL_INVALID_VALUE\0", GL_INVALID_VALUE}, 
  {"GL_INVERT\0", GL_INVERT}, 
  {"GL_KEEP\0", GL_KEEP}, 
  {"GL_LEFT\0", GL_LEFT}, 
  {"GL_LEQUAL\0", GL_LEQUAL}, 
  {"GL_LESS\0", GL_LESS}, 
  {"GL_LIGHT0\0", GL_LIGHT0}, 
  {"GL_LIGHT1\0", GL_LIGHT1}, 
  {"GL_LIGHT2\0", GL_LIGHT2}, 
  {"GL_LIGHT3\0", GL_LIGHT3}, 
  {"GL_LIGHT4\0", GL_LIGHT4}, 
  {"GL_LIGHT5\0", GL_LIGHT5}, 
  {"GL_LIGHT6\0", GL_LIGHT6}, 
  {"GL_LIGHT7\0", GL_LIGHT7}, 
  {"GL_LIGHTING\0", GL_LIGHTING}, 
  {"GL_LIGHTING_BIT\0", GL_LIGHTING_BIT}, 
  {"GL_LIGHT_MODEL_AMBIENT\0", GL_LIGHT_MODEL_AMBIENT}, 
  {"GL_LIGHT_MODEL_LOCAL_VIEWER\0", GL_LIGHT_MODEL_LOCAL_VIEWER}, 
  {"GL_LIGHT_MODEL_TWO_SIDE\0", GL_LIGHT_MODEL_TWO_SIDE}, 
  {"GL_LINEAR\0", GL_LINEAR}, 
  {"GL_LINEAR_ATTENUATION\0", GL_LINEAR_ATTENUATION}, 
  {"GL_LINEAR_MIPMAP_LINEAR\0", GL_LINEAR_MIPMAP_LINEAR}, 
  {"GL_LINEAR_MIPMAP_NEAREST\0", GL_LINEAR_MIPMAP_NEAREST}, 
  {"GL_LINES\0", GL_LINES}, 
  {"GL_LINE\0", GL_LINE}, 
  {"GL_LINE_BIT\0", GL_LINE_BIT}, 
  {"GL_LINE_LOOP\0", GL_LINE_LOOP}, 
  {"GL_LINE_RESET_TOKEN\0", GL_LINE_RESET_TOKEN}, 
  {"GL_LINE_SMOOTH\0", GL_LINE_SMOOTH}, 
  {"GL_LINE_SMOOTH_HINT\0", GL_LINE_SMOOTH_HINT}, 
  {"GL_LINE_STIPPLE\0", GL_LINE_STIPPLE}, 
  {"GL_LINE_STIPPLE_PATTERN\0", GL_LINE_STIPPLE_PATTERN}, 
  {"GL_LINE_STIPPLE_REPEAT\0", GL_LINE_STIPPLE_REPEAT}, 
  {"GL_LINE_STRIP\0", GL_LINE_STRIP}, 
  {"GL_LINE_TOKEN\0", GL_LINE_TOKEN}, 
  {"GL_LINE_WIDTH\0", GL_LINE_WIDTH}, 
  {"GL_LINE_WIDTH_GRANULARITY\0", GL_LINE_WIDTH_GRANULARITY}, 
  {"GL_LINE_WIDTH_RANGE\0", GL_LINE_WIDTH_RANGE}, 
  {"GL_LIST_BASE\0", GL_LIST_BASE}, 
  {"GL_LIST_BIT\0", GL_LIST_BIT}, 
  {"GL_LIST_INDEX\0", GL_LIST_INDEX}, 
  {"GL_LIST_MODE\0", GL_LIST_MODE}, 
  {"GL_LOAD\0", GL_LOAD},
  {"GL_LOGIC_OP\0", GL_LOGIC_OP}, 
  {"GL_LOGIC_OP_MODE\0", GL_LOGIC_OP_MODE}, 
  {"GL_LUMINANCE\0", GL_LUMINANCE}, 
  {"GL_LUMINANCE_ALPHA\0", GL_LUMINANCE_ALPHA}, 
  {"GL_MAP1_COLOR_4\0", GL_MAP1_COLOR_4}, 
  {"GL_MAP1_GRID_DOMAIN\0", GL_MAP1_GRID_DOMAIN}, 
  {"GL_MAP1_GRID_SEGMENTS\0", GL_MAP1_GRID_SEGMENTS}, 
  {"GL_MAP1_INDEX\0", GL_MAP1_INDEX}, 
  {"GL_MAP1_NORMAL\0", GL_MAP1_NORMAL}, 
  {"GL_MAP1_TEXTURE_COORD_1\0", GL_MAP1_TEXTURE_COORD_1}, 
  {"GL_MAP1_TEXTURE_COORD_2\0", GL_MAP1_TEXTURE_COORD_2}, 
  {"GL_MAP1_TEXTURE_COORD_3\0", GL_MAP1_TEXTURE_COORD_3}, 
  {"GL_MAP1_TEXTURE_COORD_4\0", GL_MAP1_TEXTURE_COORD_4}, 
  {"GL_MAP1_VERTEX_3\0", GL_MAP1_VERTEX_3}, 
  {"GL_MAP1_VERTEX_4\0", GL_MAP1_VERTEX_4}, 
  {"GL_MAP2_COLOR_4\0", GL_MAP2_COLOR_4}, 
  {"GL_MAP2_GRID_DOMAIN\0", GL_MAP2_GRID_DOMAIN}, 
  {"GL_MAP2_GRID_SEGMENTS\0", GL_MAP2_GRID_SEGMENTS}, 
  {"GL_MAP2_INDEX\0", GL_MAP2_INDEX}, 
  {"GL_MAP2_NORMAL\0", GL_MAP2_NORMAL}, 
  {"GL_MAP2_TEXTURE_COORD_1\0", GL_MAP2_TEXTURE_COORD_1}, 
  {"GL_MAP2_TEXTURE_COORD_2\0", GL_MAP2_TEXTURE_COORD_2}, 
  {"GL_MAP2_TEXTURE_COORD_3\0", GL_MAP2_TEXTURE_COORD_3}, 
  {"GL_MAP2_TEXTURE_COORD_4\0", GL_MAP2_TEXTURE_COORD_4}, 
  {"GL_MAP2_VERTEX_3\0", GL_MAP2_VERTEX_3}, 
  {"GL_MAP2_VERTEX_4\0", GL_MAP2_VERTEX_4}, 
  {"GL_MAP_COLOR\0", GL_MAP_COLOR}, 
  {"GL_MAP_STENCIL\0", GL_MAP_STENCIL}, 
  {"GL_MATRIX_MODE\0", GL_MATRIX_MODE}, 
  {"GL_MAX_ATTRIB_STACK_DEPTH\0", GL_MAX_ATTRIB_STACK_DEPTH}, 
  {"GL_MAX_CLIP_PLANES\0", GL_MAX_CLIP_PLANES}, 
  {"GL_MAX_EVAL_ORDER\0", GL_MAX_EVAL_ORDER}, 
  {"GL_MAX_LIGHTS\0", GL_MAX_LIGHTS}, 
  {"GL_MAX_LIST_NESTING\0", GL_MAX_LIST_NESTING}, 
  {"GL_MAX_MODELVIEW_STACK_DEPTH\0", GL_MAX_MODELVIEW_STACK_DEPTH}, 
  {"GL_MAX_NAME_STACK_DEPTH\0", GL_MAX_NAME_STACK_DEPTH}, 
  {"GL_MAX_PIXEL_MAP_TABLE\0", GL_MAX_PIXEL_MAP_TABLE}, 
  {"GL_MAX_PROJECTION_STACK_DEPTH\0", GL_MAX_PROJECTION_STACK_DEPTH}, 
  {"GL_MAX_TEXTURE_SIZE\0", GL_MAX_TEXTURE_SIZE}, 
  {"GL_MAX_TEXTURE_STACK_DEPTH\0", GL_MAX_TEXTURE_STACK_DEPTH}, 
  {"GL_MAX_VIEWPORT_DIMS\0", GL_MAX_VIEWPORT_DIMS}, 
  {"GL_MODELVIEW\0", GL_MODELVIEW}, 
  {"GL_MODELVIEW_MATRIX\0", GL_MODELVIEW_MATRIX}, 
  {"GL_MODELVIEW_STACK_DEPTH\0", GL_MODELVIEW_STACK_DEPTH}, 
  {"GL_MODULATE\0", GL_MODULATE}, 
  {"GL_MULT\0", GL_MULT}, 
  {"GL_NAME_STACK_DEPTH\0", GL_NAME_STACK_DEPTH}, 
  {"GL_NAND\0", GL_NAND}, 
  {"GL_NEAREST\0", GL_NEAREST}, 
  {"GL_NEAREST_MIPMAP_LINEAR\0", GL_NEAREST_MIPMAP_LINEAR}, 
  {"GL_NEAREST_MIPMAP_NEAREST\0", GL_NEAREST_MIPMAP_NEAREST}, 
  {"GL_NEVER\0", GL_NEVER}, 
  {"GL_NICEST\0", GL_NICEST}, 
  {"GL_NONE\0", GL_NONE}, 
  {"GL_NOOP\0", GL_NOOP}, 
  {"GL_NORMALIZE\0", GL_NORMALIZE}, 
  {"GL_NOR\0", GL_NOR}, 
  {"GL_NOTEQUAL\0", GL_NOTEQUAL}, 
  {"GL_NO_ERROR\0", GL_NO_ERROR}, 
  {"GL_OBJECT_LINEAR\0", GL_OBJECT_LINEAR}, 
  {"GL_OBJECT_PLANE\0", GL_OBJECT_PLANE}, 
  {"GL_ONE\0", GL_ONE}, 
  {"GL_ONE_MINUS_DST_ALPHA\0", GL_ONE_MINUS_DST_ALPHA}, 
  {"GL_ONE_MINUS_DST_COLOR\0", GL_ONE_MINUS_DST_COLOR}, 
  {"GL_ONE_MINUS_SRC_ALPHA\0", GL_ONE_MINUS_SRC_ALPHA}, 
  {"GL_ONE_MINUS_SRC_COLOR\0", GL_ONE_MINUS_SRC_COLOR}, 
  {"GL_ORDER\0", GL_ORDER}, 
  {"GL_OR\0", GL_OR}, 
  {"GL_OR_INVERTED\0", GL_OR_INVERTED}, 
  {"GL_OR_REVERSE\0", GL_OR_REVERSE}, 
  {"GL_OUT_OF_MEMORY\0", GL_OUT_OF_MEMORY}, 
  {"GL_PACK_ALIGNMENT\0", GL_PACK_ALIGNMENT}, 
  {"GL_PACK_LSB_FIRST\0", GL_PACK_LSB_FIRST}, 
  {"GL_PACK_ROW_LENGTH\0", GL_PACK_ROW_LENGTH}, 
  {"GL_PACK_SKIP_PIXELS\0", GL_PACK_SKIP_PIXELS}, 
  {"GL_PACK_SKIP_ROWS\0", GL_PACK_SKIP_ROWS}, 
  {"GL_PACK_SWAP_BYTES\0", GL_PACK_SWAP_BYTES}, 
  {"GL_PASS_THROUGH_TOKEN\0", GL_PASS_THROUGH_TOKEN}, 
  {"GL_PERSPECTIVE_CORRECTION_HINT\0", GL_PERSPECTIVE_CORRECTION_HINT}, 
  {"GL_PIXEL_MAP_A_TO_A\0", GL_PIXEL_MAP_A_TO_A}, 
  {"GL_PIXEL_MAP_A_TO_A_SIZE\0", GL_PIXEL_MAP_A_TO_A_SIZE}, 
  {"GL_PIXEL_MAP_B_TO_B\0", GL_PIXEL_MAP_B_TO_B}, 
  {"GL_PIXEL_MAP_B_TO_B_SIZE\0", GL_PIXEL_MAP_B_TO_B_SIZE}, 
  {"GL_PIXEL_MAP_G_TO_G\0", GL_PIXEL_MAP_G_TO_G}, 
  {"GL_PIXEL_MAP_G_TO_G_SIZE\0", GL_PIXEL_MAP_G_TO_G_SIZE}, 
  {"GL_PIXEL_MAP_I_TO_A\0", GL_PIXEL_MAP_I_TO_A}, 
  {"GL_PIXEL_MAP_I_TO_A_SIZE\0", GL_PIXEL_MAP_I_TO_A_SIZE}, 
  {"GL_PIXEL_MAP_I_TO_B\0", GL_PIXEL_MAP_I_TO_B}, 
  {"GL_PIXEL_MAP_I_TO_B_SIZE\0", GL_PIXEL_MAP_I_TO_B_SIZE}, 
  {"GL_PIXEL_MAP_I_TO_G\0", GL_PIXEL_MAP_I_TO_G}, 
  {"GL_PIXEL_MAP_I_TO_G_SIZE\0", GL_PIXEL_MAP_I_TO_G_SIZE}, 
  {"GL_PIXEL_MAP_I_TO_I\0", GL_PIXEL_MAP_I_TO_I}, 
  {"GL_PIXEL_MAP_I_TO_I_SIZE\0", GL_PIXEL_MAP_I_TO_I_SIZE}, 
  {"GL_PIXEL_MAP_I_TO_R\0", GL_PIXEL_MAP_I_TO_R}, 
  {"GL_PIXEL_MAP_I_TO_R_SIZE\0", GL_PIXEL_MAP_I_TO_R_SIZE}, 
  {"GL_PIXEL_MAP_R_TO_R\0", GL_PIXEL_MAP_R_TO_R}, 
  {"GL_PIXEL_MAP_R_TO_R_SIZE\0", GL_PIXEL_MAP_R_TO_R_SIZE}, 
  {"GL_PIXEL_MAP_S_TO_S\0", GL_PIXEL_MAP_S_TO_S}, 
  {"GL_PIXEL_MAP_S_TO_S_SIZE\0", GL_PIXEL_MAP_S_TO_S_SIZE}, 
  {"GL_PIXEL_MODE_BIT\0", GL_PIXEL_MODE_BIT}, 
  {"GL_POINTS\0", GL_POINTS}, 
  {"GL_POINT\0", GL_POINT}, 
  {"GL_POINT_BIT\0", GL_POINT_BIT}, 
  {"GL_POINT_SIZE\0", GL_POINT_SIZE}, 
  {"GL_POINT_SIZE_GRANULARITY\0", GL_POINT_SIZE_GRANULARITY}, 
  {"GL_POINT_SIZE_RANGE\0", GL_POINT_SIZE_RANGE}, 
  {"GL_POINT_SMOOTH\0", GL_POINT_SMOOTH}, 
  {"GL_POINT_SMOOTH_HINT\0", GL_POINT_SMOOTH_HINT}, 
  {"GL_POINT_TOKEN\0", GL_POINT_TOKEN}, 
  {"GL_POLYGON\0", GL_POLYGON}, 
  {"GL_POLYGON_BIT\0", GL_POLYGON_BIT}, 
  {"GL_POLYGON_MODE\0", GL_POLYGON_MODE}, 
  {"GL_POLYGON_SMOOTH\0", GL_POLYGON_SMOOTH}, 
  {"GL_POLYGON_SMOOTH_HINT\0", GL_POLYGON_SMOOTH_HINT}, 
  {"GL_POLYGON_STIPPLE\0", GL_POLYGON_STIPPLE}, 
  {"GL_POLYGON_STIPPLE_BIT\0", GL_POLYGON_STIPPLE_BIT}, 
  {"GL_POLYGON_TOKEN\0", GL_POLYGON_TOKEN}, 
  {"GL_POSITION\0", GL_POSITION}, 
  {"GL_PROJECTION\0", GL_PROJECTION}, 
  {"GL_PROJECTION_MATRIX\0", GL_PROJECTION_MATRIX}, 
  {"GL_PROJECTION_STACK_DEPTH\0", GL_PROJECTION_STACK_DEPTH}, 
  {"GL_QUADRATIC_ATTENUATION\0", GL_QUADRATIC_ATTENUATION}, 
  {"GL_QUADS\0", GL_QUADS}, 
  {"GL_QUAD_STRIP\0", GL_QUAD_STRIP}, 
  {"GL_Q\0", GL_Q}, 
  {"GL_READ_BUFFER\0", GL_READ_BUFFER}, 
  {"GL_RED\0", GL_RED}, 
  {"GL_RED_BIAS\0", GL_RED_BIAS}, 
  {"GL_RED_BITS\0", GL_RED_BITS}, 
  {"GL_RED_SCALE\0", GL_RED_SCALE}, 
  {"GL_RENDERER\0", GL_RENDERER}, 
  {"GL_RENDER\0", GL_RENDER}, 
  {"GL_RENDER_MODE\0", GL_RENDER_MODE}, 
  {"GL_REPEAT\0", GL_REPEAT}, 
  {"GL_REPLACE\0", GL_REPLACE}, 
  {"GL_RETURN\0", GL_RETURN},
  {"GL_RGBA\0", GL_RGBA}, 
  {"GL_RGBA_MODE\0", GL_RGBA_MODE}, 
  {"GL_RGB\0", GL_RGB}, 
  {"GL_RIGHT\0", GL_RIGHT}, 
  {"GL_R\0", GL_R}, 
  {"GL_SCISSOR_BIT\0", GL_SCISSOR_BIT}, 
  {"GL_SCISSOR_BOX\0", GL_SCISSOR_BOX}, 
  {"GL_SCISSOR_TEST\0", GL_SCISSOR_TEST}, 
  {"GL_SELECT\0", GL_SELECT}, 
  {"GL_SET\0", GL_SET}, 
  {"GL_SHADE_MODEL\0", GL_SHADE_MODEL}, 
  {"GL_SHININESS\0", GL_SHININESS}, 
  {"GL_SHORT\0", GL_SHORT}, 
  {"GL_SMOOTH\0", GL_SMOOTH}, 
  {"GL_SPECULAR\0", GL_SPECULAR}, 
  {"GL_SPHERE_MAP\0", GL_SPHERE_MAP}, 
  {"GL_SPOT_CUTOFF\0", GL_SPOT_CUTOFF}, 
  {"GL_SPOT_DIRECTION\0", GL_SPOT_DIRECTION}, 
  {"GL_SPOT_EXPONENT\0", GL_SPOT_EXPONENT}, 
  {"GL_SRC_ALPHA\0", GL_SRC_ALPHA}, 
  {"GL_SRC_ALPHA_SATURATE\0", GL_SRC_ALPHA_SATURATE}, 
  {"GL_SRC_COLOR\0", GL_SRC_COLOR}, 
  {"GL_STACK_OVERFLOW\0", GL_STACK_OVERFLOW}, 
  {"GL_STACK_UNDERFLOW\0", GL_STACK_UNDERFLOW}, 
  {"GL_STENCIL\0", GL_STENCIL}, 
  {"GL_STENCIL_BITS\0", GL_STENCIL_BITS}, 
  {"GL_STENCIL_BUFFER_BIT\0", GL_STENCIL_BUFFER_BIT}, 
  {"GL_STENCIL_CLEAR_VALUE\0", GL_STENCIL_CLEAR_VALUE}, 
  {"GL_STENCIL_FAIL\0", GL_STENCIL_FAIL}, 
  {"GL_STENCIL_FUNC\0", GL_STENCIL_FUNC}, 
  {"GL_STENCIL_INDEX\0", GL_STENCIL_INDEX}, 
  {"GL_STENCIL_PASS_DEPTH_FAIL\0", GL_STENCIL_PASS_DEPTH_FAIL}, 
  {"GL_STENCIL_PASS_DEPTH_PASS\0", GL_STENCIL_PASS_DEPTH_PASS}, 
  {"GL_STENCIL_REF\0", GL_STENCIL_REF}, 
  {"GL_STENCIL_TEST\0", GL_STENCIL_TEST}, 
  {"GL_STENCIL_VALUE_MASK\0", GL_STENCIL_VALUE_MASK}, 
  {"GL_STENCIL_WRITEMASK\0", GL_STENCIL_WRITEMASK}, 
  {"GL_STEREO\0", GL_STEREO}, 
  {"GL_SUBPIXEL_BITS\0", GL_SUBPIXEL_BITS}, 
  {"GL_S\0", GL_S}, 
  {"GL_TEXTURE\0", GL_TEXTURE}, 
  {"GL_TEXTURE_1D\0", GL_TEXTURE_1D}, 
  {"GL_TEXTURE_2D\0", GL_TEXTURE_2D}, 
  {"GL_TEXTURE_BIT\0", GL_TEXTURE_BIT}, 
  {"GL_TEXTURE_BORDER\0", GL_TEXTURE_BORDER}, 
  {"GL_TEXTURE_BORDER_COLOR\0", GL_TEXTURE_BORDER_COLOR}, 
  {"GL_TEXTURE_COMPONENTS\0", GL_TEXTURE_COMPONENTS}, 
  {"GL_TEXTURE_ENV\0", GL_TEXTURE_ENV}, 
  {"GL_TEXTURE_ENV_COLOR\0", GL_TEXTURE_ENV_COLOR}, 
  {"GL_TEXTURE_ENV_MODE\0", GL_TEXTURE_ENV_MODE}, 
  {"GL_TEXTURE_GEN_MODE\0", GL_TEXTURE_GEN_MODE}, 
  {"GL_TEXTURE_GEN_Q\0", GL_TEXTURE_GEN_Q}, 
  {"GL_TEXTURE_GEN_R\0", GL_TEXTURE_GEN_R}, 
  {"GL_TEXTURE_GEN_S\0", GL_TEXTURE_GEN_S}, 
  {"GL_TEXTURE_GEN_T\0", GL_TEXTURE_GEN_T}, 
  {"GL_TEXTURE_HEIGHT\0", GL_TEXTURE_HEIGHT}, 
  {"GL_TEXTURE_MAG_FILTER\0", GL_TEXTURE_MAG_FILTER}, 
  {"GL_TEXTURE_MATRIX\0", GL_TEXTURE_MATRIX}, 
  {"GL_TEXTURE_MIN_FILTER\0", GL_TEXTURE_MIN_FILTER}, 
  {"GL_TEXTURE_STACK_DEPTH\0", GL_TEXTURE_STACK_DEPTH}, 
  {"GL_TEXTURE_WIDTH\0", GL_TEXTURE_WIDTH}, 
  {"GL_TEXTURE_WRAP_S\0", GL_TEXTURE_WRAP_S}, 
  {"GL_TEXTURE_WRAP_T\0", GL_TEXTURE_WRAP_T}, 
  {"GL_TRANSFORM_BIT\0", GL_TRANSFORM_BIT}, 
  {"GL_TRIANGLES\0", GL_TRIANGLES}, 
  {"GL_TRIANGLE_FAN\0", GL_TRIANGLE_FAN}, 
  {"GL_TRIANGLE_STRIP\0", GL_TRIANGLE_STRIP}, 
  {"GL_TRUE\0", GL_TRUE}, 
  {"GL_T\0", GL_T}, 
  {"GL_UNPACK_ALIGNMENT\0", GL_UNPACK_ALIGNMENT}, 
  {"GL_UNPACK_LSB_FIRST\0", GL_UNPACK_LSB_FIRST}, 
  {"GL_UNPACK_ROW_LENGTH\0", GL_UNPACK_ROW_LENGTH}, 
  {"GL_UNPACK_SKIP_PIXELS\0", GL_UNPACK_SKIP_PIXELS}, 
  {"GL_UNPACK_SKIP_ROWS\0", GL_UNPACK_SKIP_ROWS}, 
  {"GL_UNPACK_SWAP_BYTES\0", GL_UNPACK_SWAP_BYTES}, 
  {"GL_UNSIGNED_BYTE\0", GL_UNSIGNED_BYTE}, 
  {"GL_UNSIGNED_INT\0", GL_UNSIGNED_INT}, 
  {"GL_UNSIGNED_SHORT\0", GL_UNSIGNED_SHORT}, 
  {"GL_VENDOR\0", GL_VENDOR}, 
  {"GL_VERSION\0", GL_VERSION}, 
  {"GL_VIEWPORT\0", GL_VIEWPORT}, 
  {"GL_VIEWPORT_BIT\0", GL_VIEWPORT_BIT}, 
  {"GL_XOR\0", GL_XOR}, 
  {"GL_ZERO\0", GL_ZERO}, 
  {"GL_ZOOM_X\0", GL_ZOOM_X}, 
  {"GL_ZOOM_Y\0", GL_ZOOM_Y}
};
#endif
